---
type: api
title: Create a monitor
description: **Spaces method and path for this operation:**
url: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/kibana/v8/operation/operation-post-synthetic-monitors
resource: https://www.elastic.co/elastic/docs-builder/docs/4371/api/doc/kibana/v8/operation/operation-post-synthetic-monitors
products:
  - Kibana
---

# Create a monitor

- Server: `https://{kibana_url}`

## Paths

- `POST` `/api/synthetics/monitors`
- `POST` `/s/{space_id}/api/synthetics/monitors`

- [Api key auth](/elastic/docs-builder/docs/4371/api/doc/kibana/v8/authentication#apikeyauth)
- [Basic auth](/elastic/docs-builder/docs/4371/api/doc/kibana/v8/authentication#basicauth)

## Description

Refer to [Spaces](https://www.elastic.co/docs/deploy-manage/manage-spaces) for more information.

Create a new monitor with the specified attributes. A monitor can be one of the following types: HTTP, TCP, ICMP, or Browser. The required and default fields may vary based on the monitor type.
You must have `all` privileges for the Synthetics feature in the Observability section of the Kibana feature privileges.

## Request Body

`application/json`

One of:
- **Synthetics_browserMonitorFields** (`type: browser`)
  - `alert` (object) — optional
    The alert configuration. The default is `{ status: { enabled: true }, tls: { enabled: true } }`.
  - `enabled` (boolean · default: true) — optional
    Specify whether the monitor is enabled.
  - `labels` (map string to string) — optional
    Key-value pairs of labels to associate with the monitor. Labels can be used for filtering and grouping monitors.
  - `locations` ([] string) — optional
    The location to deploy the monitor.
Monitors can be deployed in multiple locations so that you can detect differences in availability and response times across those locations.
To list available locations you can:

- Run the `elastic-synthetics locations` command with the deployment's Kibana URL.
- Go to *Synthetics > Management* and click *Create monitor*. Locations will be listed in *Locations*.
  - `name` (string) — required
    The monitor name.
  - `namespace` (string · default: default) — optional
    The namespace field should be lowercase and not contain spaces. The namespace must not include any of the following characters: `*`, `\`, `/`, `?`, `"`, `<`, `>`, `|`, whitespace, `,`, `#`, `:`, or `-`.
  - `params` (string) — optional
    The monitor parameters.
  - `private_locations` ([] string) — optional
    The private locations to which the monitors will be deployed.
These private locations refer to locations hosted and managed by you, whereas `locations` are hosted by Elastic.
You can specify a private location using the location's name.
To list available private locations you can:

- Run the `elastic-synthetics locations` command with the deployment's Kibana URL.
- Go to *Synthetics > Settings* and click *Private locationsr*. Private locations will be listed in the table.

> info
> You can provide `locations` or `private_locations` or both. At least one is required.
  - `retest_on_failure` (boolean · default: true) — optional
    Turn retesting for when a monitor fails on or off. By default, monitors are automatically retested if the monitor goes from "up" to "down". If the result of the retest is also "down", an error will be created and if configured, an alert sent. The monitor will then resume running according to the defined schedule. Using `retest_on_failure` can reduce noise related to transient problems.
  - `schedule` (number) — optional
    The monitor's schedule in minutes. Supported values are `1`, `3`, `5`, `10`, `15`, `30`, `60`, `120`, and `240`. The default value is `3` minutes for HTTP, TCP, and ICMP monitors. The default value is `10` minutes for Browser monitors.
  - `service.name` (string) — optional
    The APM service name.
  - `tags` ([] string) — optional
    An array of tags.
  - `timeout` (number · default: 16) — optional
    The monitor timeout in seconds. The monitor will fail if it doesn't complete within this time.
  - `ignore_https_errors` (boolean · default: false) — optional
    Ignore HTTPS errors.
  - `inline_script` (string) — required
    The inline script.
  - `playwright_options` (object) — optional
    Playwright options.
  - `screenshots` (enum  · default: on) — optional
    The screenshot option.
    Values: `on`, `off`, `only-on-failure`
  - `synthetics_args` ([] string) — optional
    Synthetics agent CLI arguments.
  - `type` (enum) — required
    The monitor type.
    Values: `browser`
- **Synthetics_httpMonitorFields** (`type: http`)
  - `alert` (object) — optional
    The alert configuration. The default is `{ status: { enabled: true }, tls: { enabled: true } }`.
  - `enabled` (boolean · default: true) — optional
    Specify whether the monitor is enabled.
  - `labels` (map string to string) — optional
    Key-value pairs of labels to associate with the monitor. Labels can be used for filtering and grouping monitors.
  - `locations` ([] string) — optional
    The location to deploy the monitor.
Monitors can be deployed in multiple locations so that you can detect differences in availability and response times across those locations.
To list available locations you can:

- Run the `elastic-synthetics locations` command with the deployment's Kibana URL.
- Go to *Synthetics > Management* and click *Create monitor*. Locations will be listed in *Locations*.
  - `name` (string) — required
    The monitor name.
  - `namespace` (string · default: default) — optional
    The namespace field should be lowercase and not contain spaces. The namespace must not include any of the following characters: `*`, `\`, `/`, `?`, `"`, `<`, `>`, `|`, whitespace, `,`, `#`, `:`, or `-`.
  - `params` (string) — optional
    The monitor parameters.
  - `private_locations` ([] string) — optional
    The private locations to which the monitors will be deployed.
These private locations refer to locations hosted and managed by you, whereas `locations` are hosted by Elastic.
You can specify a private location using the location's name.
To list available private locations you can:

- Run the `elastic-synthetics locations` command with the deployment's Kibana URL.
- Go to *Synthetics > Settings* and click *Private locationsr*. Private locations will be listed in the table.

> info
> You can provide `locations` or `private_locations` or both. At least one is required.
  - `retest_on_failure` (boolean · default: true) — optional
    Turn retesting for when a monitor fails on or off. By default, monitors are automatically retested if the monitor goes from "up" to "down". If the result of the retest is also "down", an error will be created and if configured, an alert sent. The monitor will then resume running according to the defined schedule. Using `retest_on_failure` can reduce noise related to transient problems.
  - `schedule` (number) — optional
    The monitor's schedule in minutes. Supported values are `1`, `3`, `5`, `10`, `15`, `30`, `60`, `120`, and `240`. The default value is `3` minutes for HTTP, TCP, and ICMP monitors. The default value is `10` minutes for Browser monitors.
  - `service.name` (string) — optional
    The APM service name.
  - `tags` ([] string) — optional
    An array of tags.
  - `timeout` (number · default: 16) — optional
    The monitor timeout in seconds. The monitor will fail if it doesn't complete within this time.
  - `check` (object) — optional
    The check request settings.
    - `request` (object) — optional
      An optional request to send to the remote host.
      - `body` (string) — optional
        Optional request body content.
      - `headers` (object) — optional
        A dictionary of additional HTTP headers to send. By default, Synthetics will set the User-Agent header to identify itself.
      - `method` (enum) — optional
        The HTTP method to use.
        Values: `HEAD`, `GET`, `POST`, `OPTIONS`
    - `response` (object) — optional
      The expected response.
      - `body` (object) — optional
      - `headers` (object) — optional
        A dictionary of expected HTTP headers. If the header is not found, the check fails.
  - `ipv4` (boolean · default: true) — optional
    If `true`, ping using the ipv4 protocol.
  - `ipv6` (boolean · default: true) — optional
    If `true`, ping using the ipv6 protocol.
  - `max_redirects` (number · default: 0) — optional
    The maximum number of redirects to follow.
  - `mode` (enum  · default: any) — optional
    The mode of the monitor. If it is `all`, the monitor pings all resolvable IPs for a hostname. If it is `any`, the monitor pings only one IP address for a hostname. If you're using a DNS-load balancer and want to ping every IP address for the specified hostname, you should use `all`.
    Values: `all`, `any`
  - `password` (string) — optional
    The password for authenticating with the server. The credentials are passed with the request.
  - `proxy_headers` (object) — optional
    Additional headers to send to proxies during CONNECT requests.
  - `proxy_url` (string) — optional
    The URL of the proxy to use for this monitor.
  - `response` (object) — optional
    Controls the indexing of the HTTP response body contents to the `http.response.body.contents field`.
  - `ssl` (object) — optional
    The TLS/SSL connection settings for use with the HTTPS endpoint. If you don't specify settings, the system defaults are used.
  - `type` (enum) — required
    The monitor type.
    Values: `http`
  - `url` (string) — required
    The URL to monitor.
  - `username` (string) — optional
    The username for authenticating with the server. The credentials are passed with the request.
- **Synthetics_icmpMonitorFields** (`type: icmp`)
  - `alert` (object) — optional
    The alert configuration. The default is `{ status: { enabled: true }, tls: { enabled: true } }`.
  - `enabled` (boolean · default: true) — optional
    Specify whether the monitor is enabled.
  - `labels` (map string to string) — optional
    Key-value pairs of labels to associate with the monitor. Labels can be used for filtering and grouping monitors.
  - `locations` ([] string) — optional
    The location to deploy the monitor.
Monitors can be deployed in multiple locations so that you can detect differences in availability and response times across those locations.
To list available locations you can:

- Run the `elastic-synthetics locations` command with the deployment's Kibana URL.
- Go to *Synthetics > Management* and click *Create monitor*. Locations will be listed in *Locations*.
  - `name` (string) — required
    The monitor name.
  - `namespace` (string · default: default) — optional
    The namespace field should be lowercase and not contain spaces. The namespace must not include any of the following characters: `*`, `\`, `/`, `?`, `"`, `<`, `>`, `|`, whitespace, `,`, `#`, `:`, or `-`.
  - `params` (string) — optional
    The monitor parameters.
  - `private_locations` ([] string) — optional
    The private locations to which the monitors will be deployed.
These private locations refer to locations hosted and managed by you, whereas `locations` are hosted by Elastic.
You can specify a private location using the location's name.
To list available private locations you can:

- Run the `elastic-synthetics locations` command with the deployment's Kibana URL.
- Go to *Synthetics > Settings* and click *Private locationsr*. Private locations will be listed in the table.

> info
> You can provide `locations` or `private_locations` or both. At least one is required.
  - `retest_on_failure` (boolean · default: true) — optional
    Turn retesting for when a monitor fails on or off. By default, monitors are automatically retested if the monitor goes from "up" to "down". If the result of the retest is also "down", an error will be created and if configured, an alert sent. The monitor will then resume running according to the defined schedule. Using `retest_on_failure` can reduce noise related to transient problems.
  - `schedule` (number) — optional
    The monitor's schedule in minutes. Supported values are `1`, `3`, `5`, `10`, `15`, `30`, `60`, `120`, and `240`. The default value is `3` minutes for HTTP, TCP, and ICMP monitors. The default value is `10` minutes for Browser monitors.
  - `service.name` (string) — optional
    The APM service name.
  - `tags` ([] string) — optional
    An array of tags.
  - `timeout` (number · default: 16) — optional
    The monitor timeout in seconds. The monitor will fail if it doesn't complete within this time.
  - `host` (string) — required
    The host to ping.
  - `type` (enum) — required
    The monitor type.
    Values: `icmp`
  - `wait` (number · default: 1) — optional
    The wait time in seconds.
- **Synthetics_tcpMonitorFields** (`type: tcp`)
  - `alert` (object) — optional
    The alert configuration. The default is `{ status: { enabled: true }, tls: { enabled: true } }`.
  - `enabled` (boolean · default: true) — optional
    Specify whether the monitor is enabled.
  - `labels` (map string to string) — optional
    Key-value pairs of labels to associate with the monitor. Labels can be used for filtering and grouping monitors.
  - `locations` ([] string) — optional
    The location to deploy the monitor.
Monitors can be deployed in multiple locations so that you can detect differences in availability and response times across those locations.
To list available locations you can:

- Run the `elastic-synthetics locations` command with the deployment's Kibana URL.
- Go to *Synthetics > Management* and click *Create monitor*. Locations will be listed in *Locations*.
  - `name` (string) — required
    The monitor name.
  - `namespace` (string · default: default) — optional
    The namespace field should be lowercase and not contain spaces. The namespace must not include any of the following characters: `*`, `\`, `/`, `?`, `"`, `<`, `>`, `|`, whitespace, `,`, `#`, `:`, or `-`.
  - `params` (string) — optional
    The monitor parameters.
  - `private_locations` ([] string) — optional
    The private locations to which the monitors will be deployed.
These private locations refer to locations hosted and managed by you, whereas `locations` are hosted by Elastic.
You can specify a private location using the location's name.
To list available private locations you can:

- Run the `elastic-synthetics locations` command with the deployment's Kibana URL.
- Go to *Synthetics > Settings* and click *Private locationsr*. Private locations will be listed in the table.

> info
> You can provide `locations` or `private_locations` or both. At least one is required.
  - `retest_on_failure` (boolean · default: true) — optional
    Turn retesting for when a monitor fails on or off. By default, monitors are automatically retested if the monitor goes from "up" to "down". If the result of the retest is also "down", an error will be created and if configured, an alert sent. The monitor will then resume running according to the defined schedule. Using `retest_on_failure` can reduce noise related to transient problems.
  - `schedule` (number) — optional
    The monitor's schedule in minutes. Supported values are `1`, `3`, `5`, `10`, `15`, `30`, `60`, `120`, and `240`. The default value is `3` minutes for HTTP, TCP, and ICMP monitors. The default value is `10` minutes for Browser monitors.
  - `service.name` (string) — optional
    The APM service name.
  - `tags` ([] string) — optional
    An array of tags.
  - `timeout` (number · default: 16) — optional
    The monitor timeout in seconds. The monitor will fail if it doesn't complete within this time.
  - `host` (string) — required
    The host to monitor; it can be an IP address or a hostname. The host can include the port using a colon, for example "example.com:9200".
  - `proxy_url` (string) — optional
    The URL of the SOCKS5 proxy to use when connecting to the server. The value must be a URL with a scheme of `socks5://`. If the SOCKS5 proxy server requires client authentication, then a username and password can be embedded in the URL. When using a proxy, hostnames are resolved on the proxy server instead of on the client. You can change this behavior by setting the `proxy_use_local_resolver` option.
  - `proxy_use_local_resolver` (boolean · default: false) — optional
    Specify that hostnames are resolved locally instead of being resolved on the proxy server. If `false`, name resolution occurs on the proxy server.
  - `ssl` (object) — optional
    The TLS/SSL connection settings for use with the HTTPS endpoint. If you don't specify settings, the system defaults are used.
  - `type` (enum) — required
    The monitor type.
    Values: `tcp`

## Response

A successful response.

## Code Examples

#### Console

```console
POST /api/synthetics/monitors
{
  "type": "http",
  "name": "Website Availability",
  "url": "https://example.com",
  "tags": ["website", "availability"],
  "locations": ["united_kingdom"]
}
```

#### curl

```curl
curl -X POST "https://{kibana_url}/api/synthetics/monitors" \
  -H "Content-Type: application/json" \
  -d '{
  "type": "http",
  "name": "Website Availability",
  "url": "https://example.com",
  "tags": ["website", "availability"],
  "locations": ["united_kingdom"]
}'
```

